#include <stdio.h>

#define EUCMASK 0x80

void euc2code(FILE* fp)
{
    int ch;

    while((ch = fgetc(fp)) != EOF)
    {
	if((ch & EUCMASK) && ch != EOF)
	    printf("%2X", ch);
	else
	    putchar(ch);
    }
}

int main(int argc, char **argv)
{
    int status = 0;

    if(argc == 1)
	euc2code(stdin);
    else
    {
	int i;
	FILE *fp;

	for(i = 1; i < argc; i++)
	{
	    if((fp = fopen(argv[i], "r")) == NULL)
	    {
		status = 1;
		perror(argv[i]);
		continue;
	    }
	    euc2code(fp);
	    fclose(fp);
	}
    }

    return status;
}
