#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>

int main(int argc, char** argv)
{
    int i;
    int float_time = 0;
    int once = 0;

    for(i = 1; i < argc; i++)
    {
	if(!strcmp(argv[i], "-f"))
	    float_time = 1;
	else if(!strcmp(argv[i], "-1"))
	    once = 1;
	else
	{
	    fprintf(stderr, "Invalid argument: %s\n", argv[i]);
	    fprintf(stderr, "Usage: %s [-1] [-f]\n", argv[0]);
	    return 1;
	}
    }

    
    while(1)
    {
	struct timeval tv;
	char buff[BUFSIZ];
	/*
	 * SVR4 has gettimeofday() without timezone
	 */
#ifdef SVR4
	gettimeofday(&tv);
#else
	gettimeofday(&tv, NULL);
#endif

	if(float_time)
	    sprintf(buff, "%ld.%06ld\r", tv.tv_sec, tv.tv_usec);
	else
	    sprintf(buff, "%ld\r", tv.tv_sec);
	write(1, buff, strlen(buff));
	if(once)
	{
	    write(1, "\n", 1);
	    return 0;
	}
    }
    return 0;
}
